// container.h, v1

#include "library.h"
#include <string>
#include <iostream>


template <class ElementType>
class MyContainer {
public:
   MyContainer(const std::string iName) : instanceName(iName) 
   {}
   // class implementation
   // ...
   
   // fetch the policy being used
   void doPolicy();
   // a service that uses the policy
   void performService() { doPolicy(); }
   
   const std::string instanceName;
};

// elements for example's sake
template<class T>
struct Element1 {
// ...
};

template<class T>
struct Element2 {
// ...
};


template <class ElementType>
void MyContainer<ElementType>::doPolicy() 
{ 
    std::cout << "Policy is: " << CLASS_POLICY << std::endl;
}
